#ifndef KEY_H	 /* to assert that only one occurrence is included */
    #define KEY_H
/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	Copyright (C) 1995 ADClone Inc. 				    ;;
;;									    ;;
;;	Module	: key.h   key definition				    ;;
;;	Author	: Richard Lin						    ;;
;;	Date	:  6/16/1995						    ;;
;;	Rev.	: 1.00							    ;;
;;	Modified: None							    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

/*----- INCLUDE -----------------------------------------------------------*/
#include    "std.h"

/*----- CONSTANT ----------------------------------------------------------*/

#define KEY_UP		    0x4800
#define KEY_DOWN	    0x5000
#define KEY_LEFT	    0x4b00
#define KEY_RIGHT	    0x4d00
#define KEY_HOME	    0x4700
#define KEY_END 	    0x4F00
#define KEY_PGUP	    0x4900
#define KEY_PGDN	    0x5100
#define KEY_INS 	    0x5200
#define KEY_DEL 	    0x5300




#define KEY_BACKSPACE	    0x0e08
#define KEY_TAB 	    0x0f09
#define KEY_SPACE	    0x3920
#define KEY_ESC 	    0x011b
#define KEY_ENTER	    0x1c0d

#define KEY_F1		    0x3b00
#define KEY_F2		    0x3c00
#define KEY_F3		    0x3d00
#define KEY_F4		    0x3e00
#define KEY_F5		    0x3f00
#define KEY_F6		    0x4000
#define KEY_F7		    0x4100
#define KEY_F8		    0x4200
#define KEY_F9		    0x4300
#define KEY_F10 	    0x4400

#define KEY_CTRL_F1	    0x5E00
#define KEY_CTRL_F2	    0x5F00
#define KEY_CTRL_F3	    0x6000
#define KEY_CTRL_F4	    0x6100
#define KEY_CTRL_F5	    0x6200
#define KEY_CTRL_F6	    0x6300
#define KEY_CTRL_F7	    0x6400
#define KEY_CTRL_F8	    0x6500
#define KEY_CTRL_F9	    0x6600
#define KEY_CTRL_F10	    0x6700


#define KEY_CTRL_UP	    0x8d00
#define KEY_CTRL_DOWN	    0x9100
#define KEY_CTRL_LEFT	    0x7300
#define KEY_CTRL_RIGHT	    0x7400
#define KEY_CTRL_HOME	    0x7700
#define KEY_CTRL_END	    0x7500
#define KEY_CTRL_PGUP	    0x8400
#define KEY_CTRL_PGDN	    0x7600
#define KEY_CTRL_INS	    0x9200
#define KEY_CTRL_DEL	    0x9300
#define KEY_CTRL_BACKSPACE  0x0e7f



#define KEY_ALT_F1	    0x6800
#define KEY_ALT_F2	    0x6900
#define KEY_ALT_F3	    0x6A00
#define KEY_ALT_F4	    0x6B00
#define KEY_ALT_F5	    0x6C00
#define KEY_ALT_F6	    0x6D00
#define KEY_ALT_F7	    0x6E00
#define KEY_ALT_F8	    0x6F00
#define KEY_ALT_F9	    0x7000
#define KEY_ALT_F10	    0x7100

#define KEY_ALT_A	    0x1E00
#define KEY_ALT_B	    0x3000
#define KEY_ALT_C	    0x2E00
#define KEY_ALT_D	    0x2000
#define KEY_ALT_E	    0x1200
#define KEY_ALT_F	    0x2100
#define KEY_ALT_G	    0x2200
#define KEY_ALT_H	    0x2300
#define KEY_ALT_I	    0x1700
#define KEY_ALT_J	    0x2400
#define KEY_ALT_K	    0x2500
#define KEY_ALT_L	    0x2600
#define KEY_ALT_M	    0x3200
#define KEY_ALT_N	    0x3100
#define KEY_ALT_O	    0x1800
#define KEY_ALT_P	    0x1900
#define KEY_ALT_Q	    0x1000
#define KEY_ALT_R	    0x1300
#define KEY_ALT_S	    0x1F00
#define KEY_ALT_T	    0x1400
#define KEY_ALT_U	    0x1600
#define KEY_ALT_V	    0x2F00
#define KEY_ALT_W	    0x1100
#define KEY_ALT_X	    0x2D00
#define KEY_ALT_Y	    0x1500
#define KEY_ALT_Z	    0x2C00

#define KEY_0		    0x0b30
#define KEY_1		    0x0231
#define KEY_2		    0x0332
#define KEY_3		    0x0433
#define KEY_4		    0x0534
#define KEY_5		    0x0635
#define KEY_6		    0x0736
#define KEY_7		    0x0837
#define KEY_8		    0x0938
#define KEY_9		    0x0a39

#define     key_Hit()		kbhit()

/*----- VARIBLES ---------------------------------------------------------*/

#ifdef KEY_C
    #define EXTERN
#else
    #define EXTERN  extern
#endif


#undef EXTERN
/*----- FUNCTIONS ---------------------------------------------------------*/

extern void	    key_Bell(void);
extern std_Word     key_Get(void);
extern void	    key_Flush(void);
/*-------------------------------------------------------------------------*/
#endif	/* end of #ifdef KEY_H	*/
