#ifndef STD_H /* to assert that only one occurrence is included */
    #define  STD_H

/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1996, ADLink Technology Inc.  All rights reserved.  ;;
;;									   ;;
;;	File Name   :	std.h						   ;;
;;	Purpose     :	Standard common constant			   ;;
;;	Date	    :	8/8/1996					   ;;
;;	Revision    :	1.1						   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

#include <stdio.h>


#define std_Public
#define std_Private	static
#define std_Local	static

typedef unsigned char	BOOLEAN;
typedef BOOLEAN 	std_Boolean;
typedef void		std_Void;

#define FALSE		0
#define TRUE		(!FALSE)
#define STD_FALSE	FALSE
#define STD_TRUE	TRUE

#define YES		TRUE
#define NO		FALSE
#define STD_YES 	TRUE
#define STD_NO		FALSE

#define ON		TRUE
#define OFF		FALSE
#define STD_ON		TRUE
#define STD_OFF 	FALSE

typedef unsigned char	BYTE;
typedef unsigned short	WORD;
typedef unsigned long	DWORD;

typedef BYTE		std_Byte;
typedef WORD		std_Word;
typedef BYTE		std_UByte;
typedef WORD		std_UWord;
typedef DWORD		std_DWord;
typedef DWORD		std_ULong;


/*------------------ Bite Definition -----------------------*/
#define STD_BIT0	0x01
#define STD_BIT1	0x02
#define STD_BIT2	0x04
#define STD_BIT3	0x08
#define STD_BIT4	0x10
#define STD_BIT5	0x20
#define STD_BIT6	0x40
#define STD_BIT7	0x80
#define STD_BIT8	0x0100
#define STD_BIT9	0x0200
#define STD_BIT10	0x0400
#define STD_BIT11	0x0800
#define STD_BIT12	0x1000
#define STD_BIT13	0x2000
#define STD_BIT14	0x4000
#define STD_BIT15	0x8000
#define STD_BIT16	0x10000L
#define STD_BIT17	0x20000L
#define STD_BIT18	0x40000L
#define STD_BIT19	0x80000L
#define STD_BIT20	0x100000L
#define STD_BIT21	0x200000L
#define STD_BIT22	0x400000L
#define STD_BIT23	0x800000L
#define STD_BIT24	0x1000000L
#define STD_BIT25	0x2000000L
#define STD_BIT26	0x4000000L
#define STD_BIT27	0x8000000L
#define STD_BIT28	0x10000000L
#define STD_BIT29	0x20000000L
#define STD_BIT30	0x40000000L
#define STD_BIT31	0x80000000L

/*--------------------------- Bit Operation ------------------------------*/
#define std_SetBitsOn(anyVal, ORedBits) \
					((anyVal) |= (ORedBits))

#define std_SetBitsOff(anyVal, ORedBits) \
					((anyVal) &= ~(ORedBits))

#define std_TestBitsOff(anyVal, ORedBits) \
					(((anyVal) & (ORedBits)) == 0)

#define std_TestBitsOn(anyVal, ORedBits) \
					(((anyVal) & (ORedBits)) != 0)

#define std_TakeBits(aUnsignedVal, bitPosition, nBits) \
	((((unsigned)(aUnsignedVal)) >> \
		((bitPosition)+1-(nBits))) & ~(~0 << (nBits)))

#define std_LeftShift(anyVal, nBits) \
					((anyVal) <<= (nBits))

#define std_RightShift(anyVal, nBits) \
					((anyVal) >>= (nBits))


#define std_min(a, b)	(((a) < (b)) ? (a) : (b))
#define std_max(a, b)	(((a) > (b)) ? (a) : (b))
#define std_abs(x)	((x) < 0 ? -(x) : (x))

/*------------------------------------------------------------------------*/
#endif /* end of #ifndef STD_H */
