/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1997, ADLink Technology Inc.  All rights reserved.  ;;
;;                                                                         ;;
;;      File Name   :   DO_DEMO2.C                                         ;;
;;      Purpose     :   Demo program of PCI-7250 digital output            ;;
;;      Date        :   6/18/1997                                          ;;
;;      Revision    :   1.00                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "aclerr.h"
#include "std.h"
#include "video.h"
#include "key.h"
#include "acl_pci.H"

#define ACL_TitleColor      (WHITE | bgcolor(GREEN))
#define ACL_TextColor       (WHITE | bgcolor(BLUE))
#define ACL_BkColor         (BLUE | bgcolor(BLUE))
#define ACL_MsgColor        (RED|INVERSE)
#define ACL_ProgColor       (WHITE | bgcolor(BROWN))


U8  *acl_Title = "****** PCI-7250 DO DEMO (Multiple) ******";
U8  *acl_Copyright="Copyright (c) 1995-1997, ADLink Technology Inc.  All rights reserved.";

struct  {
    U16 extExist[3];
} pci_ExtInfo[MAX_PCI_CARDS];

/*----------------------------------------------------------------------*/

void showMessage(std_UByte *msg)
{
    video_ClearBox(24, 0, 24, 79, INVERSE);
    video_CenterPutStr(24, msg, ACL_MsgColor);
}
/*----------------------------------------------------------------------*/

void main( void )
{
    I16     i, j, err, row, col, key;
    U16     doData, tmpBuf[80];
    U16     existCards, curCardNo;
    PCI_INFO        info;

    /*---------- PCI-7250 initial ------------------------------------------*/
    err = _7250_Initial(&existCards, &info);
    if(err != ERR_NoError) {
        printf("PCI BIOS does not exist\n");
        exit(1);
    }
    if(existCards == 0) {
        printf("PCI-7250 does not exist\n");
        exit(1);
    }
    if(existCards < 2) {
        printf("Sorry ! This program need two PCI-7250 cards\n");
        exit(1);
    }

    for(i=0; i<existCards; i++) {
        for(j=0; j<3; j++) {
            pci_ExtInfo[i].extExist[j] = _7251_Check_Exist(i, j+1);
        }
    }
    /*----------------------------------------------------------------------*/
    video_Initial();
    video_CursorOff();
    video_Box(VIDEO_SINGLE, 0, 0,  4, 79, ACL_TitleColor);
    video_Box(VIDEO_DOUBLE, 5, 0, 23, 79, ACL_TextColor);
    video_ClearBox(24, 0, 24, 79, INVERSE | BLUE);
    video_CenterPutStr(1, acl_Title, ACL_TitleColor);
    video_CenterPutStr(3, acl_Copyright, ACL_TitleColor);
    showMessage(">>> Press any key to change DO value, <Esc> to quit <<<");


    sprintf(tmpBuf, "Total exist PCI-7250 card number = %d", existCards);
    video_CenterPutStr(6, tmpBuf, INVERSE);
    row = 10;
    col = 10;
    doData = 1;

    video_PutStr(row-2, col+25,"DO_PORT0  DO_PORT1  DO_PORT2  DO_PORT3 ", ACL_TextColor);
    video_PutStr(row-1, col+25,"========  ========  ========  ======== ", ACL_TextColor);
    for(i=0; i<existCards; i++) {
        sprintf(tmpBuf, "PCI-7250 #%d output =", i);
        video_PutStr(row+i, col, tmpBuf, ACL_TextColor);
        _7250_DO(i, DO_PORT0, doData);
        sprintf(tmpBuf, "%02X", doData);
        video_PutStr(row+i, col+4+25, tmpBuf, INVERSE);
        for(j=0; j<3; j++) {
            if(pci_ExtInfo[i].extExist[j] != PCI_7251_EXIST) {
                video_PutStr(row+i, col+25+10*(j+1), "no exist", ACL_TextColor);
            } else {
                _7250_DO(i, j+1, doData);
                sprintf(tmpBuf, "%02X", doData);
                video_PutStr(row+i, col+4+25+10*(j+1), tmpBuf, INVERSE);
            }
        }
    }

    getch();
    curCardNo = PCI_CARD1;

    key = !KEY_ESC;
    do {
        if(key_Hit()) {
            key = key_Get();
            doData++;
            if(key == KEY_ESC) doData = 0;
                for(i=0; i<existCards; i++) {
                    sprintf(tmpBuf, "%02X", doData);
                    video_PutStr(row+i, col+4+25, tmpBuf, INVERSE);
                    _7250_DO(i, DO_PORT0, doData);
                    for(j=0; j<3; j++) {
                        if(pci_ExtInfo[i].extExist[j] == PCI_7251_EXIST) {
                            _7250_DO(i, j+1, doData);
                            sprintf(tmpBuf, "%02X", doData);
                            video_PutStr(row+i, col+4+25+10*(j+1), tmpBuf, INVERSE);
                        }
                    }
                }

        }
    } while(key != KEY_ESC);
    video_CursorOn();
    video_ClearBox(24, 0, 24, 79, NORMAL);
}
