#ifndef VIDEO_H    /* to assert that only one occurrence is included */
    #define VIDEO_H
/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Copyright (c) 1995-1996, ADLink Technology Inc.  All rights reserved.   ;;
;;                                                                          ;;
;;      Module  : video.h video function                                    ;;
;;      Date    : 8/8/1996                                                  ;;
;;      Rev.    : 1.10                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

/*----- INCLUDE -----------------------------------------------------------*/

/*----- CONSTANT ----------------------------------------------------------*/
#define     VIDEO_CURSORON          1
#define     VIDEO_CURSOROFF         1
#define     VIDEO_STORE             0x8000

/* ------ border type ------ */
#define     VIDEO_NOBORDER          0
#define     VIDEO_GRAYLEVEL         1
#define     VIDEO_SINGLE            2
#define     VIDEO_DOUBLE            3

#if !defined(__COLORS)
#define __COLORS
enum COLORS {
    BLACK,          /* dark colors */
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,       /* light colors */
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};
#endif
#define BLINK           128 /* blink bit */
#define INVERSE         0x70
#define NORMAL          0x07
#define bgcolor(a)      ((a) << 4)

/*----- VARIBLES ---------------------------------------------------------*/

#ifdef VIDEO_C
    #define EXTERN
#else
    #define EXTERN  extern
#endif

EXTERN  std_Byte    video_Mode;

/*----- FUNCTIONS ---------------------------------------------------------*/

EXTERN void video_Initial();
EXTERN void video_Scroll(int x1, int y1, int x2, int y2, int attr, int control);
EXTERN void video_ClearBox(int x1, int y1, int x2, int y2, int attr);
EXTERN void video_PutStr(int x, int y, char *str, int attr);
EXTERN void video_CenterPutStr(int x, char *str, int attr);
EXTERN void video_PutChar( char a_byte, int attr);
EXTERN void video_CursorOff(void);
EXTERN void video_CursorOn(void);
EXTERN void video_Gotoxy(int x, int y);

EXTERN std_Byte video_GetMode(void);
EXTERN void video_Box(int type, int x1, int y1, int x2, int y2, int attr);
EXTERN void video_PageScroll(int x1, int y1, int x2, int y2, int attr, int control);

/*-------------------------------------------------------------------------*/
#undef EXTERN
#endif  /* end of #ifdef VIDEO_H  */

